/****************************************************************************/
/* IPMON version 1.0                                                        */
/****************************************************************************/
/* You can redistribute this program as much as you want.  All I ask is     */
/* that you give credit where credit is due.  If you make modifications or  */
/* bug fixes, please send them to me so they can be incorporated into the   */
/* next release.                                                            */
/*                                                                          */
/* IPMON takes its basic packet processing shell from NFSWATCH.  Much       */
/* thanks to the creators of NFSWATCH:                                      */
/*                                                                          */
/* Dave Curry					Jeff Mogul                  */
/* SRI International				Digital Equipment Corp.     */
/* 333 Ravenswood Avenue			Western Research Laboratory */
/* Menlo Park, CA 94025				100 Hamilton Avenue         */
/* davy@erg.sri.com				Palo Alto, CA 94301         */
/* 						mogul@decwrl.dec.com        */
/*                                                                          */
/* For a good set of base code for me to hack and build on.                 */
/*                                                                          */
/* Randall Stewart                                                          */
/* Fujitsu Network Switching                                                */
/* 4403 Bland Road                                                          */
/* Raleigh, N.C. 27609                                                      */
/* rrs%fns-nc1%mcnc-ort@uunet.uu.net                                        */
/****************************************************************************/
/*
 * Version number.
 */
#define VERSION		"1.0 4 Feburary 1992"

/*
 * General definitions.
 */
#ifndef TRUE
#define TRUE		1
#define FALSE		0
#endif /* TRUE */

#define PROMPT		"ipmon>"	/* prompt string		*/
#define CYCLETIME	10		/* screen update cycle time	*/
#define PACKETSIZE	4096		/* max size of a packet		*/
#define MAXHOSTADDR	8		/* max. network addrs per host	*/
#define	MAXCLIENTS	256		/* max. # of client counters	*/
					/* MUST be even number 		*/
#define MAXINTERFACES	16		/* Max. number of interfaces	*/


#define TCPVALUE 8
#define UDPVALUE 9
#define UNKNOWN_VALUE 10
#define UNKNOWNIP_VALUE 11
#define ICMPVALUE 12
#define REVARP_VALUE 14
/*
 * Network Interface Tap (NIT) definitions.
 */
#define NIT_DEV		"/dev/nit"	/* network interface tap device	*/
#define NIT_BUF		"nbuf"		/* nit stream buffering module	*/
#define NIT_CHUNKSIZE	8192		/* chunk size for grabbing pkts	*/

#define MAXNUMOFPORTS	65536		/* highest port number */
#define NUMOFBUFS	16		/* number of circular buf's alloc'd */
#define MAXICMPMSG	32		/* highest icmp number */
typedef unsigned long	Counter;

#define INTERVAL	0
#define SUMTOTAL	1

/*
 * Packet counting structure.
 */
typedef struct {
	char	*pc_name;		/* name of counter		*/

	Counter	*pc_total;		/* packets since start		*/
	short	pc_intx, pc_inty;	/* screen coords of pc_interval	*/
	short	pc_totx, pc_toty;	/* screen coords of pc_total	*/
	short	pc_namex, pc_namey;	/* screen coords of pc_name	*/
	long	port;
} PacketCounter;

/* shared memory index stuff.. */
#define bufInHead foo[0]
#define bufInTail foo[1]
#define bufInTOP  foo[2]
#define bufInEND  foo[3]

/*
 * Definitions for earlier systems which don't have these from 4.3BSD.
 */
#ifndef MAXHOSTNAMELEN
# define MAXHOSTNAMELEN	64
#endif /* MAXHOSTNAMELEN */

#ifndef NFDBITS
  typedef long		fd_mask;

# define NFDBITS	(sizeof(fd_mask) * NBBY)

# define FD_SET(n, p)	((p)->fds_bits[(n)/NFDBITS] |= (1 << ((n) % NFDBITS)))
# define FD_CLR(n, p)	((p)->fds_bits[(n)/NFDBITS] &= ~(1 << ((n) % NFDBITS)))
# define FD_ISSET(n, p)	((p)->fds_bits[(n)/NFDBITS] & (1 << ((n) % NFDBITS)))
# define FD_ZERO(p)	(void) bzero((char *)(p), sizeof(*(p)))
#endif /* NFDBITS */
