/****************************************************************************/
/* IPMON version 1.0                                                        */
/****************************************************************************/
/* You can redistribute this program as much as you want.  All I ask is     */
/* that you give credit where credit is due.  If you make modifications or  */
/* bug fixes, please send them to me so they can be incorporated into the   */
/* next release.                                                            */
/*                                                                          */
/* IPMON takes its basic packet processing shell from NFSWATCH.  Much       */
/* thanks to the creators of NFSWATCH:                                      */
/*                                                                          */
/* Dave Curry					Jeff Mogul                  */
/* SRI International				Digital Equipment Corp.     */
/* 333 Ravenswood Avenue			Western Research Laboratory */
/* Menlo Park, CA 94025				100 Hamilton Avenue         */
/* davy@erg.sri.com				Palo Alto, CA 94301         */
/* 						mogul@decwrl.dec.com        */
/*                                                                          */
/* For a good set of base code for me to hack and build on.                 */
/*                                                                          */
/* Randall Stewart                                                          */
/* Fujitsu Network Switching                                                */
/* 4403 Bland Road                                                          */
/* Raleigh, N.C. 27609                                                      */
/* rrs%fns-nc1%mcnc-ort@uunet.uu.net                                        */
/****************************************************************************/
#include <sys/types.h>
#include <stdio.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/ipc.h>
#include <sys/sem.h>

/* semaphore structures used by locking get_semy and put_semy */

static key_t key=0;		/* key for ftok */
static int semid=-1;		/* semid and set */
/*union semun {			 semaphore semctl structure
	int val;
	struct semid_ds *buf;
	ushort *array;
	} arg;
comment out for sun
*/
union semun arg;	/* added for sun */
struct sembuf sops[1];

get_semy()
{
/* using the num decrement the semaphore by one */
/* this provides a standard access to a semaphore */
/* First we must find the semaphore.  If it does not exist */
/* we must create it.  After finding then we must decrement it */
/*
 * get or create semaphore
 * if created
 *    init semaphore to 1
 *  endif
 * setup decrement operation
 * decrement semaphore (this will cause a block if it is zero)
 * return 0
 */

	if(semid == -1){
		key = ftok("/etc/rc",'A');
		arg.val = 1;
		semid = semget(key,1,0666);
		if(semid == -1){
			/* can't get semaphore */
			/* try to create and init it */
			semid = semget(key,1,(0666|IPC_CREAT));
			if(semid == -1){
				/* still can't get error out */
				exit(-1);
			}
			/* set it up to be 1 */
			if(semctl(semid,0,SETVAL,arg)== -1){
				/* can't init properly */
				exit(-1);
			}
		/* all ok now go on down to semop */
		}
	}

	sops[0].sem_num = 0;
	sops[0].sem_op = -1;
	sops[0].sem_flg = SEM_UNDO;

	if(semop(semid,sops,1) == -1){
		perror("semop failed");
		return(-1);
	}
	/* a ok go for it */
	return(0);
}


put_semy()
{
/* using the num decrement the semaphore by one */
/* this provides a standard access to semaphores for */
/* all idsn-mate billing processes. */
/* first we must find the semaphore.  If it does not exist */
/* we must create it.  After finding then we must decrement it */
/*
 * get or create semaphore
 * if created
 *    init semaphore to 1
 *    return 0
 *  endif
 * setup increment operation
 * increment semaphore
 * return 0
 */

	if(semid != -1){
		key = ftok("/etc/rc",'A');
		arg.val = 1;
		semid = semget(key,1,0666);
		if(semid == -1){
			/* can't get semaphore */
			/* try to create and init it */
			semid = semget(key,1,(0666|IPC_CREAT));
			if(semid == -1){
				/* still can't get error out */
				exit(-2);
			}
			/* set it up to be 1 */
			if(semctl(semid,0,SETVAL,arg) == -1){
				/* can't init properly */
				exit(-2);
			}
			/* no need to semop since it is now one */
			return(0);
		}
		if(semctl(semid,0,GETVAL,arg) > 0){
			/* semaphore is already above 0 refuse to do it */
			return(1);
		}
	}
	sops[0].sem_num = 0;
	sops[0].sem_op = 1;
	sops[0].sem_flg = SEM_UNDO;

	if(semop(semid,sops,1) == -1){
		perror("semop failed");
		return(-3);
	}

	/* a ok go for it */
	return(0);
}
